# A codec for JIS X 0201 Roman
# Tamito KAJIYAMA <4 December 2000>

import codecs
import UserDict

class Codec(codecs.Codec):
    def encode(self,input,errors='strict'):
        return codecs.charmap_encode(input,errors,encoding_map)
    def decode(self,input,errors='strict'):
        return codecs.charmap_decode(input,errors,decoding_map)

class StreamWriter(Codec,codecs.StreamWriter):
    pass
        
class StreamReader(Codec,codecs.StreamReader):
    pass

### encodings module API

def getregentry():
    return (Codec().encode,Codec().decode,StreamReader,StreamWriter)

class Mapping(UserDict.UserDict):
    def __getitem__(self, key):
        return self.get(key)

decoding_map = Mapping({})
for c in range(0x21, 0x7f):
    decoding_map[c] = c
decoding_map[0x5c] = 0xa5 # U+00A5 YEN SIGN
decoding_map[0x7e] = 0xaf # U+00AF MACRON

encoding_map = Mapping({})
for k, v in decoding_map.items():
    encoding_map[v] = k
